""" Script for generating statistics from sensitive workload data.

It would produce aggregated data per group (privatized). And finally per day 
and hour statistics.

The idea of this script is to create a release of aggregated statistics 
which does not allow for unprivatizing of the gid (which for me is SLURM's
account)

Copyright (C) 2024
Manuel G. Marciani
BSC-CNS Earth Sciences Department
"""

# library to handle differential privacy
import opendp.prelude as dp
# in-house library for handling workload format
import pyswf

if __name__ == "__main__":
    # load data
    workload = pyswf.SWFtrace.from_swf("/home/mgimenez/Documents/local/wrapper paper/workloads/CEA-Curie/original/CEA-Curie-2011-2.1-cln.swf")
    # compute core per seconds
    workload.job_list["core_seconds"] = workload.job_list.alloc_cpus * workload.job_list.runtime 
    
    # invariants: submit, start, end, uid, gid (account)

    # private: alloc_cpus, runtime, core_seconds
    df_runtime = workload.job_list.core_seconds 
    df_core_seconds = workload.job_list.core_seconds 
    df_uid = workload.job_list.core_seconds 
    df_alloc_cpus = workload.job_list.core_seconds 
    df_alloc_cpus = workload.job_list.core_seconds 

    # we want anonymized per 
    core_seconds_preproc = (
        dp.t.make_select_column("core_seconds") >>
    )
